# This file is a template, and might need editing before it works on your project.
# use the official gcc image, based on debian
# can use verions as well, like gcc:5.2
# see https://hub.docker.com/_/gcc/
#image: gcc

#build:
#  stage: build
  # instead of calling g++ directly you can also use some build toolkit like make
  # install the necessary build tools when needed
  # before_script:
  #   - apt update && apt -y install make autoconf
#  script:
#    - g++ helloworld.cpp -o mybinary
#  artifacts:
#    paths:
#      - mybinary
      # depending on your build setup it's most likely a good idea to cache outputs to reduce the build time
      # cache:
      #   paths:
      #     - "*.o"

# run tests using the binary built before
#test:
#  stage: test
#  script:
#    - ./runmytests.sh


build_docker_x86:
  stage: .pre
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --cache --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/docker/Dockerfile.x86 --destination $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME


build:
  artifacts:
    when: always
    name: "$env:CI_JOB_STAGE-$env:CI_COMMIT_REF_NAME"
    paths:
      - build/Testing

    reports:
      junit: "build/Testing/**/*.xml"
  image: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
  stage: build
  script:
    - cmake -B build
    - cmake --build build -v
    - cmake --build build --target test_memcheck
  after_script:
    - ls -1 build/Testing/*/*.xml | xargs -I{} -n1 sh -c 'php tests/ctestConverter/filter.php {} | xsltproc -o {} tests/ctestConverter/ctest2junit.xsl -'



